"""
This module contains various auxiliary function used by pyvolution.
"""


import numpy

def mean(x):
    return numpy.sum(x)/len(x)


def gradient(x0, x1, q0, q1):

    if q1-q0 != 0:
        a = (q1-q0)/(x1-x0)
    else:
        a = 0
        
    return a

def  minmod(beta_p,beta_m):
    if (abs(beta_p) < abs(beta_m)) & (beta_p*beta_m > 0.0):
        phi = beta_p
    elif (abs(beta_m) < abs(beta_p)) & (beta_p*beta_m > 0.0):
        phi = beta_m
    else:
        phi = 0.0
    return phi

def  minmod_kurganov(a,b,c):
    from numpy import sign
    if sign(a)==sign(b)==sign(c):
        return sign(a)*min(abs(a),abs(b),abs(c))
    else:
        return 0.0

def  maxmod(a,b):
    if (abs(a) > abs(b)) & (a*b > 0.0):
        phi = a
    elif (abs(b) > abs(a)) & (a*b > 0.0):
        phi = b
    else:
        phi = 0.0
    return phi

def vanleer(a,b):
    if abs(a)+abs(b) > 1e-12:
        return (a*abs(b)+abs(a)*b)/(abs(a)+abs(b))
    else:
        return 0.0

def vanalbada(a,b):
    if a*a+b*b > 1e-12:
        return (a*a*b+a*b*b)/(a*a+b*b)
    else:
        return 0.0

